'use strict';

var Promise = require("bluebird");
var rfr = require("rfr");
var electron = require("electron");
var path = require("path");

var awaitReady = rfr("lib/electron/await-ready");
var windowManagerCreator = rfr("lib/electron/window-manager");
var viewUrlCreator = rfr("lib/electron/view-url");

var windowManager = windowManagerCreator();

var viewUrl = viewUrlCreator(path.join(__dirname, "lib/views"), {
	extension: "html"
});

var useLiveReload = process.env.NODE_ENV === "development";

var windows = {};

Promise.try(function () {
	return awaitReady(electron.app);
}).then(function () {
	windowManager.create({
		width: 800,
		height: 600,
		url: viewUrl("index"),
		liveReload: useLiveReload
	});
});
